## yade 2018.02b

=== CMakeLists.txt ===
# The YADE has the following parameters to configure:
#  CMAKE_INSTALL_PREFIX: path, where Yade will be installed (/usr/local by default)
#  LIBRARY_OUTPUT_PATH: path to install libraries (lib by default)
#  DEBUG: compile in debug-mode (OFF by default)
#  CMAKE_VERBOSE_MAKEFILE: output additional information during compiling (OFF by default)
#  SUFFIX: suffix, added after binary-names (version number by default)
#  NOSUFFIX: do not add a suffix after binary-name (OFF by default)
#  YADE_VERSION: explicitely set version number (is defined from git-directory by default)
#  ENABLE_GUI: enable GUI option (ON by default)
#  ENABLE_CGAL: enable CGAL option (ON by default)
#  ENABLE_VTK: enable VTK-export option (ON by default)
#  ENABLE_OPENMP: enable OpenMP-parallelizing option (ON by default)
#  ENABLE_GTS: enable GTS-option (ON by default)
#  ENABLE_GL2PS: enable GL2PS-option (ON by default)
#  ENABLE_LINSOLV: enable LINSOLV-option (ON by default)
#  ENABLE_PFVFLOW: enable PFVFLOW-option, FlowEngine (ON by default)
#  ENABLE_TWOPHASEFLOW: enable TWOPHASEFLOW-option, TwoPhaseFlowEngine (ON by default)
#  ENABLE_LBMFLOW: enable LBMFLOW-option, LBM_ENGINE (ON by default)
#  ENABLE_SPH: enable SPH-option, Smoothed Particle Hydrodynamics (OFF by default)
#  ENABLE_LIQMIGRATION: enable LIQMIGRATION-option, see [Mani2013] for details (OFF by default)
#  ENABLE_MASK_ARBITRARY: enable MASK_ARBITRARY option (OFF by default)
#  ENABLE_PROFILING: enable profiling, e.g. shows some more metrics, which can define bottlenecks of the code (OFF by default)
#  ENABLE_POTENTIAL_PARTICLES: enable potential particles option (OFF by default)
#  ENABLE_DEFORM: enable constant volume deformation engine (OFF by default)
#  ENABLE_OAR: generate a script for oar-based task scheduler (OFF by default)
#  runtimePREFIX: used for packaging, when install directory is not the same is runtime directory (/usr/local by default)
#  CHUNKSIZE: set >1, if you want several sources to be compiled at once. Increases compilation speed and RAM-consumption during it (1 by default)
#  VECTORIZE: enables vectorization and alignment in Eigen3 library, experimental (OFF by default)
#  USE_QT5: use QT5 for GUI (ON by default)

project(Yade C CXX)
cmake_minimum_required(VERSION 2.8.11)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cMake")

INCLUDE(FindPythonInterp)
INCLUDE(FindOpenMP)
INCLUDE(FindQt4)
INCLUDE(FindPkgConfig)
INCLUDE(GetVersion)
INCLUDE(FindOpenGL)
INCLUDE(FindGTS)
INCLUDE(FindGL2PS)
INCLUDE(FindCGAL)
INCLUDE(FindNumPy)
INCLUDE(FindLoki)
INCLUDE(FindPythonModule)
INCLUDE(GNUInstallDirs)


INCLUDE_DIRECTORIES (${CMAKE_SOURCE_DIR})

#===========================================================
# HACK!!! If the version of gcc is 4.8 or greater, we add -ftrack-macro-expansion=0 
# and -save-temps into compiler to reduce the memory consumption during compilation.
# See http://bugs.debian.org/726009 for more information
# Can be removed later, if gcc fixes its regression
# Taken from http://stackoverflow.com/questions/4058565/check-gcc-minor-in-cmake

EXECUTE_PROCESS(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
IF (GCC_VERSION VERSION_GREATER 4.8 OR GCC_VERSION VERSION_EQUAL 4.8)
  MESSAGE(STATUS "GCC Version >= 4.8. Adding -ftrack-macro-expansion=0 and -save-temps")
  ADD_DEFINITIONS("-ftrack-macro-expansion=0 -save-temps")
ENDIF()

#===========================================================

IF ("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang")
  ADD_DEFINITIONS("-ftemplate-depth-512 -fstack-protector ")
ELSE()
  IF (GCC_VERSION VERSION_GREATER 4.9 OR GCC_VERSION VERSION_EQUAL 4.9)
    MESSAGE(STATUS "GCC Version >= 4.9. Adding -fstack-protector-strong")
    ADD_DEFINITIONS("-fstack-protector-strong")
  ELSE()
    ADD_DEFINITIONS("-fstack-protector")
  ENDIF()
ENDIF()

SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -fPIC -O2 --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -Wall -std=c++11")

IF (DEBUG)
  SET(CMAKE_VERBOSE_MAKEFILE 1)
  SET(CMAKE_BUILD_TYPE Debug)
  ADD_DEFINITIONS("-DYADE_DEBUG -g")
ELSE (DEBUG)
  ADD_DEFINITIONS("-DNDEBUG")
ENDIF (DEBUG)

#===========================================================
# Add possibility to use local boost installation (e.g. -DLocalBoost=1.46.1)

IF ( NOT LocalBoost )
  SET(LocalBoost "1.47.0") # Minimal required Boost version
ENDIF ( NOT LocalBoost )
FIND_PACKAGE(Boost ${LocalBoost} COMPONENTS python thread filesystem iostreams regex serialization system date_time REQUIRED)
INCLUDE_DIRECTORIES (${Boost_INCLUDE_DIRS})
# for checking purpose
MESSAGE("--   Boost_VERSION: " ${Boost_VERSION})
MESSAGE("--   Boost_LIB_VERSION: " ${Boost_LIB_VERSION})
MESSAGE("--   Boost_INCLUDE_DIRS: " ${Boost_INCLUDE_DIRS})
MESSAGE("--   Boost_LIBRARIES: " ${Boost_LIBRARIES})
ADD_DEFINITIONS(-DBOOST_MATH_DISABLE_FLOAT128=1)

#===========================================================
FIND_PACKAGE(NumPy REQUIRED)
INCLUDE_DIRECTORIES(${NUMPY_INCLUDE_DIRS})

FIND_PACKAGE(Loki REQUIRED)
INCLUDE_DIRECTORIES(${LOKI_INCLUDE_DIR})

FIND_PACKAGE(Eigen3 REQUIRED)
FIND_PACKAGE(BZip2 REQUIRED)
FIND_PACKAGE(ZLIB REQUIRED)

SET(Python_ADDITIONAL_VERSIONS 2.7)
FIND_PACKAGE(PythonLibs REQUIRED)
INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})
#===========================================================

SET(DEFAULT ON CACHE INTERNAL "Default value for enabled by default options")
SET(LINKLIBS "")
SET(CONFIGURED_FEATS "")
SET(DISABLED_FEATS "")

OPTION(ENABLE_VTK "Enable VTK" ${DEFAULT})
OPTION(ENABLE_OPENMP "Enable OpenMP" ${DEFAULT})
OPTION(ENABLE_GTS "Enable GTS" ${DEFAULT})
OPTION(ENABLE_GUI "Enable GUI" ${DEFAULT})
OPTION(ENABLE_CGAL "Enable CGAL" ${DEFAULT})
OPTION(ENABLE_GL2PS "Enable GL2PS" ${DEFAULT})
OPTION(ENABLE_LINSOLV "Enable direct solver for the flow engines (experimental)" ${DEFAULT})
OPTION(ENABLE_PFVFLOW "Enable one-phase flow engines" ${DEFAULT})
OPTION(ENABLE_TWOPHASEFLOW "Enable two-phase flow engines" ${DEFAULT})
OPTION(ENABLE_SPH "Enable SPH" OFF)
OPTION(ENABLE_LBMFLOW "Enable LBM engine (very experimental)" ON)
OPTION(ENABLE_LIQMIGRATION "Enable liquid control (very experimental), see [Mani2013] for details" OFF)
OPTION(ENABLE_MASK_ARBITRARY "Enable arbitrary precision of bitmask variables (only Body::groupMask yet implemented) (experimental). Use -DMASK_ARBITRARY_SIZE=int to set number of used bits (256 by default)" OFF)
OPTION(ENABLE_PROFILING "Enable profiling, e.g. shows some more metrics, which can define bottlenecks of the code (OFF by default)" OFF)
OPTION(ENABLE_POTENTIAL_PARTICLES "Enable potential particles" OFF)
OPTION(ENABLE_OAR "Generate script for oar-based task scheduler" OFF)
OPTION(USE_QT5 "USE Qt5 for GUI" ON)
OPTION(ENABLE_POTENTIAL_BLOCKS "Enable PotentialBlocks" OFF)
OPTION(ENABLE_DEFORM "Enable Deformation Engine" OFF)
OPTION(CHOLMOD_GPU "Enable GPU acceleration flow engine direct solver (experimental)" OFF)

#===========================================================
# Use Eigen3 by default
IF (EIGEN3_FOUND)
  INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIR})
  MESSAGE(STATUS "Found Eigen3, version: ${EIGEN3_VERSION}")
  
  # Minimal required version 3.2.1
  IF ((${EIGEN3_MAJOR_VERSION} LESS 2) OR ((${EIGEN3_MAJOR_VERSION} EQUAL 2) AND (${EIGEN3_MINOR_VERSION} LESS 1)))
    MESSAGE(FATAL_ERROR "Minimal required Eigen3 version is 3.2.1, please update Eigen3!")
  ENDIF ((${EIGEN3_MAJOR_VERSION} LESS 2) OR ((${EIGEN3_MAJOR_VERSION} EQUAL 2) AND (${EIGEN3_MINOR_VERSION} LESS 1)))

  IF (NOT VECTORIZE)
    MESSAGE(STATUS "Disable vectorization")
    ADD_DEFINITIONS("-DEIGEN_DONT_VECTORIZE -DEIGEN_DONT_ALIGN -DEIGEN_DISABLE_UNALIGNED_ARRAY_ASSERT")
  ELSE (NOT VECTORIZE)
    MESSAGE(STATUS "Enable vectorization")
  ENDIF (NOT VECTORIZE)
  
ENDIF(EIGEN3_FOUND)
#===========================================================
INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIRS})
SET(LINKLIBS  "${LINKLIBS};${BZIP2_LIBRARIES};${ZLIB_LIBRARIES};")
#===========================================================
IF((Boost_MAJOR_VERSION EQUAL 1) OR (Boost_MAJOR_VERSION GREATER 1) AND
  ((Boost_MINOR_VERSION EQUAL 53) OR (Boost_MINOR_VERSION GREATER 53)))
  SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} Odeint")
  ADD_DEFINITIONS("-DYADE_ODEINT")
ELSE((Boost_MAJOR_VERSION EQUAL 1) OR (Boost_MAJOR_VERSION GREATER 1) AND
    ((Boost_MINOR_VERSION EQUAL 53) OR (Boost_MINOR_VERSION GREATER 53)))
  SET(DISABLED_FEATS "${DISABLED_FEATS} Odeint")
  MESSAGE(STATUS "Boost Odeint can be enabled, only if Boost>=1.53 is used")
ENDIF((Boost_MAJOR_VERSION EQUAL 1) OR (Boost_MAJOR_VERSION GREATER 1) AND
     ((Boost_MINOR_VERSION EQUAL 53) OR (Boost_MINOR_VERSION GREATER 53)))
#===========================================================
IF(ENABLE_VTK)
  FIND_PACKAGE(VTK COMPONENTS vtkCommonCore vtkIOImage vtkIOXML vtkFiltersCore vtkImagingCore vtkRenderingCore vtkImagingGeneral vtkImagingHybrid)
  IF(VTK_FOUND)
    INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIRS})
    LINK_DIRECTORIES( ${VTK_LIBRARY_DIRS} )
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_VTK")
    MESSAGE(STATUS "Found VTK")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} VTK")
  ELSE(VTK_FOUND)
    MESSAGE(STATUS "VTK NOT found")
    SET(ENABLE_VTK OFF)
    SET(DISABLED_FEATS "${DISABLED_FEATS} VTK")
  ENDIF(VTK_FOUND)
ELSE(ENABLE_VTK)
  SET(DISABLED_FEATS "${DISABLED_FEATS} VTK")
ENDIF(ENABLE_VTK)
#===========================================================
IF(ENABLE_OPENMP)
  FIND_PACKAGE(OpenMP)
  IF(OPENMP_FOUND)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENMP ${OpenMP_CXX_FLAGS}")
    MESSAGE(STATUS "Found OpenMP")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} OpenMP")
  ELSE(OPENMP_FOUND)
    MESSAGE(STATUS "OpenMP NOT found")
    SET(ENABLE_OPENMP OFF)
    SET(DISABLED_FEATS "${DISABLED_FEATS} OPENMP")
  ENDIF(OPENMP_FOUND)
ELSE(ENABLE_OPENMP)
  SET(DISABLED_FEATS "${DISABLED_FEATS} OPENMP")
ENDIF(ENABLE_OPENMP)
#===========================================================
IF(ENABLE_GTS)
  FIND_PACKAGE(GTS)
  FIND_PACKAGE(glib2)
  IF(GTS_FOUND AND GLIB2_FOUND)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_GTS ${CMAKE_GTS_CXX_FLAGS}")
    SET(CMAKE_LD_FLAGS  "${CMAKE_LD_FLAGS} ${GTS_LIBRARIES}")
    INCLUDE_DIRECTORIES(${GTS_INCLUDE_DIR})
    INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
    MESSAGE(STATUS "Found GTS")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GTS")
  ELSE(GTS_FOUND AND GLIB2_FOUND)
    MESSAGE(STATUS "GTS NOT found")
    SET(DISABLED_FEATS "${DISABLED_FEATS} GTS")
    SET(ENABLE_GTS OFF)
  ENDIF(GTS_FOUND AND GLIB2_FOUND)
ELSE(ENABLE_GTS)
  SET(DISABLED_FEATS "${DISABLED_FEATS} GTS")
ENDIF(ENABLE_GTS)
#===========================================================
IF(ENABLE_GUI)
  FIND_PACKAGE(OpenGL)
  FIND_PACKAGE(GLUT)
  FIND_PACKAGE(glib2)
    
  IF(USE_QT5)
    FIND_PACKAGE(QGLVIEWER-qt5 REQUIRED)
    FIND_PACKAGE(Qt5 CONFIG REQUIRED Widgets Xml OpenGL)
    SET(CMAKE_AUTOMOC ON)
    FIND_PACKAGE(Qt5Widgets)
    IF(Qt5Widgets_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
      SET(GUI_LIBS ${GLUT_LIBRARY} ${QGLVIEWER_LIBRARIES})
      SET(GUI_SRC_LIB "lib/opengl/GLUtils.cpp")
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENGL -DYADE_QT5")
      
      MESSAGE(STATUS "Found GUI-Qt5-LIBS")
      SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GUI-Qt5")
    ELSE(Qt5Widgets_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
      MESSAGE(STATUS "GUI-Qt5-LIBS NOT found")
      SET(DISABLED_FEATS "${DISABLED_FEATS} GUI-Qt5")
      SET(ENABLE_GUI OFF)
    ENDIF(Qt5Widgets_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
  ELSE(USE_QT5)   # Use Qt4
    FIND_PACKAGE(QGLVIEWER-qt4 REQUIRED)
    FIND_PACKAGE(Qt4 COMPONENTS QtCore QtGui QtOpenGL)
    IF(QT4_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
      SET(GUI_LIBS ${GLUT_LIBRARY} ${OPENGL_LIBRARY} ${QGLVIEWER_LIBRARIES})

=== gui/CMakeLists.txt ===
IF(${ENABLE_GUI})
  INCLUDE_DIRECTORIES(${QGLVIEWER_INCLUDE_DIR})
  IF(USE_QT5)
    SET(CMAKE_AUTOMOC ON)
    SET(_GLViewer_SOURCE_FILES qt5/GLViewer.cpp;qt5/_GLViewer.cpp;qt5/OpenGLManager.cpp;qt5/GLViewerDisplay.cpp;qt5/GLViewerMouse.cpp)
    ADD_LIBRARY(_GLViewer SHARED ${_GLViewer_SOURCE_FILES})
    SET_TARGET_PROPERTIES(_GLViewer PROPERTIES PREFIX "")
    TARGET_LINK_LIBRARIES(_GLViewer Qt5::Widgets Qt5::Xml Qt5::OpenGL
                                    ${GLUT_LIBRARY} ${OPENGL_LIBRARY}
                                    ${QGLVIEWER_LIBRARIES}
                                    ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
    IF(GL2PS_FOUND AND ENABLE_GL2PS)
      TARGET_LINK_LIBRARIES(_GLViewer ${GL2PS_LIBRARIES})
    ENDIF(GL2PS_FOUND AND ENABLE_GL2PS)
    INSTALL(TARGETS _GLViewer DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    FILE(GLOB filesPYQT "${CMAKE_CURRENT_SOURCE_DIR}/qt5/*.py")
    INSTALL(FILES ${filesPYQT} DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    EXECUTE_PROCESS(
          COMMAND "pyrcc5" "-o" "${CMAKE_BINARY_DIR}/img_rc.py" "img.qrc"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt5
          RESULT_VARIABLE rv
          )
    
    EXECUTE_PROCESS(
          COMMAND "pyuic5" "-o" "${CMAKE_BINARY_DIR}/ui_controller.py" "controller.ui"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt5
          RESULT_VARIABLE rv
          )
    INSTALL(FILES ${CMAKE_BINARY_DIR}/img_rc.py ${CMAKE_BINARY_DIR}/ui_controller.py  DESTINATION ${YADE_PY_PATH}/yade/qt)
    TARGET_LINK_LIBRARIES(_GLViewer Qt5::Widgets Qt5::Xml Qt5::OpenGL
                                    ${GLUT_LIBRARY} ${OPENGL_LIBRARY}
                                    ${QGLVIEWER_LIBRARIES}
                                    ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
    IF(GL2PS_FOUND AND ENABLE_GL2PS)
      TARGET_LINK_LIBRARIES(_GLViewer ${GL2PS_LIBRARIES})
    ENDIF(GL2PS_FOUND AND ENABLE_GL2PS)
    INSTALL(TARGETS _GLViewer DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    FILE(GLOB filesPYQT "${CMAKE_CURRENT_SOURCE_DIR}/qt5/*.py")
    INSTALL(FILES ${filesPYQT} DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    EXECUTE_PROCESS(
          COMMAND "pyrcc5" "-o" "${CMAKE_BINARY_DIR}/img_rc.py" "img.qrc"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt5
          RESULT_VARIABLE rv
          )
    
    EXECUTE_PROCESS(
          COMMAND "pyuic5" "-o" "${CMAKE_BINARY_DIR}/ui_controller.py" "controller.ui"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt5
          RESULT_VARIABLE rv
          )
    INSTALL(FILES ${CMAKE_BINARY_DIR}/img_rc.py ${CMAKE_BINARY_DIR}/ui_controller.py  DESTINATION ${YADE_PY_PATH}/yade/qt)
  ELSE(USE_QT5)
    INCLUDE(${QT_USE_FILE})
    
    SET(_GLViewer_MOC_HEADERS qt4/GLViewer.hpp;qt4/OpenGLManager.hpp)
    SET(_GLViewer_SOURCE_FILES qt4/GLViewer.cpp;qt4/_GLViewer.cpp;qt4/OpenGLManager.cpp;qt4/GLViewerDisplay.cpp;qt4/GLViewerMouse.cpp)
    
    QT4_WRAP_CPP(_GLViewer_MOC_OUTFILES ${_GLViewer_MOC_HEADERS})
    
    ADD_LIBRARY(_GLViewer SHARED ${_GLViewer_SOURCE_FILES} ${_GLViewer_MOC_OUTFILES})
    SET_TARGET_PROPERTIES(_GLViewer PROPERTIES PREFIX "")
    TARGET_LINK_LIBRARIES(_GLViewer ${GLUT_LIBRARY} ${OPENGL_LIBRARY} ${QT_LIBRARIES} ${QGLVIEWER_LIBRARIES} ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
    IF(GL2PS_FOUND AND ENABLE_GL2PS)
      TARGET_LINK_LIBRARIES(_GLViewer ${GL2PS_LIBRARIES})
    ENDIF(GL2PS_FOUND AND ENABLE_GL2PS)
    INSTALL(TARGETS _GLViewer DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    FILE(GLOB filesPYQT "${CMAKE_CURRENT_SOURCE_DIR}/qt4/*.py")
    INSTALL(FILES ${filesPYQT} DESTINATION ${YADE_PY_PATH}/yade/qt)
    
    EXECUTE_PROCESS(
          COMMAND "pyrcc4" "-o" "${CMAKE_BINARY_DIR}/img_rc.py" "img.qrc"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt4
          RESULT_VARIABLE rv
          )
    
    EXECUTE_PROCESS(
          COMMAND "pyuic4" "-o" "${CMAKE_BINARY_DIR}/ui_controller.py" "controller.ui"
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt4
          RESULT_VARIABLE rv
          )
    INSTALL(FILES ${CMAKE_BINARY_DIR}/img_rc.py ${CMAKE_BINARY_DIR}/ui_controller.py  DESTINATION ${YADE_PY_PATH}/yade/qt)
  ENDIF(USE_QT5)
ENDIF(${ENABLE_GUI})

=== py/CMakeLists.txt ===
#==================pygts=========================================
IF(ENABLE_GTS)
  find_python_module(gts)
  IF (PY_gts)
    MESSAGE(STATUS "Use system gts version")
  ELSE (PY_gts)
    MESSAGE(STATUS "Use embedded version of gts. Please, consider installing the corresponding package")
    FILE(GLOB SRC_PYGTS "${CMAKE_CURRENT_SOURCE_DIR}/3rd-party/pygts-0.3.1/*.c")
    ADD_LIBRARY(_gts SHARED ${SRC_PYGTS})
    SET_TARGET_PROPERTIES(_gts PROPERTIES PREFIX "")
    TARGET_LINK_LIBRARIES(_gts gts)
    INSTALL(FILES 3rd-party/pygts-0.3.1/__init__.py DESTINATION ${YADE_LIB_PATH}/py/gts)
    INSTALL(FILES 3rd-party/pygts-0.3.1/pygts.py DESTINATION ${YADE_LIB_PATH}/py/gts)
    INSTALL(TARGETS _gts DESTINATION ${YADE_LIB_PATH}/py/gts)
  ENDIF (PY_gts)
ENDIF(ENABLE_GTS)
#==================pygts=========================================

#==================pyModules=========================================

FILE(GLOB filesPY "${CMAKE_CURRENT_SOURCE_DIR}/*.py")
SET(filesPY "${filesPY};${CMAKE_CURRENT_SOURCE_DIR}/pack/pack.py")
INSTALL(FILES ${filesPY} DESTINATION ${YADE_PY_PATH}/yade)
INSTALL(FILES 3rd-party/mtTkinter-0.4/mtTkinter.py DESTINATION ${YADE_LIB_PATH}/py)
FILE(GLOB filesPYTests "${CMAKE_CURRENT_SOURCE_DIR}/tests/*.py")
INSTALL(FILES ${filesPYTests} DESTINATION ${YADE_PY_PATH}/yade/tests)
FILE(GLOB filesPYPerf "${CMAKE_CURRENT_SOURCE_DIR}/../examples/test/performance/*")
INSTALL(FILES ${filesPYPerf} DESTINATION ${YADE_PY_PATH}/yade/tests/checks/performance)
FILE(GLOB filesFEMxDEM "${CMAKE_CURRENT_SOURCE_DIR}/FEMxDEM/*.py")
INSTALL(FILES ${filesFEMxDEM} DESTINATION ${YADE_PY_PATH}/yade/FEMxDEM)
ADD_LIBRARY(WeightedAverage2d SHARED "${CMAKE_CURRENT_SOURCE_DIR}/WeightedAverage2d.cpp")
SET_TARGET_PROPERTIES(WeightedAverage2d PROPERTIES PREFIX "")
INSTALL(TARGETS WeightedAverage2d DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_utils SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_utils.cpp")
SET_TARGET_PROPERTIES(_utils PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_utils yade)
INSTALL(TARGETS _utils DESTINATION "${YADE_PY_PATH}/yade/")


ADD_LIBRARY(_polyhedra_utils SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_polyhedra_utils.cpp")
SET_TARGET_PROPERTIES(_polyhedra_utils PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_polyhedra_utils)
INSTALL(TARGETS _polyhedra_utils DESTINATION "${YADE_PY_PATH}/yade/")


ADD_LIBRARY(_packPredicates SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packPredicates.cpp")
SET_TARGET_PROPERTIES(_packPredicates PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_packPredicates yade)
IF(ENABLE_GTS AND NOT(PY_gts))
  TARGET_LINK_LIBRARIES(_packPredicates _gts)
ENDIF(ENABLE_GTS AND NOT(PY_gts))


INSTALL(TARGETS _packPredicates DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_packSpheres SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packSpheres.cpp")
SET_TARGET_PROPERTIES(_packSpheres PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_packSpheres yade)
INSTALL(TARGETS _packSpheres DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_packObb SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packObb.cpp")
SET_TARGET_PROPERTIES(_packObb PROPERTIES PREFIX "")
INSTALL(TARGETS _packObb DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(wrapper SHARED "${CMAKE_CURRENT_SOURCE_DIR}/wrapper/yadeWrapper.cpp")
SET_TARGET_PROPERTIES(wrapper PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(wrapper yade)
INSTALL(TARGETS wrapper DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_customConverters SHARED "${CMAKE_CURRENT_SOURCE_DIR}/wrapper/customConverters.cpp")
SET_TARGET_PROPERTIES(_customConverters PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_customConverters yade)
INSTALL(TARGETS _customConverters DESTINATION "${YADE_PY_PATH}/yade/")

=== debian/changelog ===
yade (2018.02b-4build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 13:26:42 +0000

yade (2018.02b-4) unstable; urgency=medium

  * [7e20ce4] Update d/copyright

 -- Anton Gladky <gladk@debian.org>  Sat, 23 Jun 2018 09:29:43 +0200

yade (2018.02b-3) unstable; urgency=medium

  * [ed63b0d] Set Arch: any for python-yade

 -- Anton Gladky <gladk@debian.org>  Tue, 19 Jun 2018 22:20:31 +0200

yade (2018.02b-2) unstable; urgency=medium

  [ Adrian Bunk ]
  * [4cf8d3c] Drop debug info for mips/mipsel. (Closes: #890237)

  [ Anton Gladky ]
  * [b87e33b] Use tar.gz instead of failing bz2 in doctest. (Closes: #900457)
  * [37a6e5b] Add tilda to debhelper version number
  * [20d3a2e] Set Standards-Version to 4.1.4
  * [ec2b9f9] Fix compilation with the newer sphinx.

 -- Anton Gladky <gladk@debian.org>  Sat, 09 Jun 2018 23:16:40 +0200

yade (2018.02b-1) unstable; urgency=medium

  [ Anton Gladky ]
  * [5a1056a] New upstream version 2018.02b
  * [fc27b02] Remove patch applied by upstream
  * [366aa18] Reenable CGAL-feature

  [ Adrian Bunk ]
  * [a5eddfb] Fix compilation on weak archs. (Closes: #890237)

 -- Anton Gladky <gladk@debian.org>  Tue, 20 Feb 2018 20:06:30 +0100

yade (2018.02a-2) unstable; urgency=medium

  * [299915c] Disable parallel build. (Closes: #890054)

 -- Anton Gladky <gladk@debian.org>  Sat, 10 Feb 2018 17:06:03 +0100

yade (2018.02a-1) unstable; urgency=medium

  * [8c51977] Add libgmp-dev as a build-dependency
  * [ca816f3] New upstream version 2018.02a
  * [4e12967] Refresh patches, remove applied by upstream
  * [862d474] Fix unit-tests
  * [5ef654a] Set Standards-Version to 4.1.3
  * [f6c9349] Remove testsuite-field in d/control
  * [f7a532e] Update VCS-field
  * [f41e35b] Update homepage
  * [13e4b8b] Enable parallel-builds. (Closes: #846919)
  * [ac653a1] Set compat-level 11
  * [e128978] Use arch-any not the explicit list of archs
  * [1066da4] Remove old patch
  * [98da1df] Update yade-doc.doc-base

 -- Anton Gladky <gladk@debian.org>  Thu, 08 Feb 2018 19:16:45 +0100

yade (2017.01a-11) unstable; urgency=medium

  * [92d9c5e] Do not enable LINSOLV if CGAL not found. (Closes: #880792)

 -- Anton Gladky <gladk@debian.org>  Sun, 05 Nov 2017 11:09:58 +0100

yade (2017.01a-10) unstable; urgency=medium

  * [246d427] Remove libcgal-dev from BD temporarly not to block CGAL
              migration. (Closes: #876524)
  * [beb17f7] Set Standards-Version: 4.1.1

 -- Anton Gladky <gladk@debian.org>  Fri, 03 Nov 2017 21:45:35 +0100

=== debian/control ===
Source: yade
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 11~),
               dh-exec,
               freeglut3-dev,
               help2man,
               ipython (>= 5),
               libboost-all-dev,
               libbz2-dev,
               libcgal-dev,
               libeigen3-dev (>= 3.2.1-2),
               libgl1-mesa-dev,
               libgmp-dev,
               libgts-dev,
               libloki-dev,
               libmetis-dev [amd64 i386 powerpc],
               libopenblas-dev [amd64 i386 powerpc],
               libqglviewer-dev-qt5,
               libsuitesparse-dev [amd64 i386 powerpc],
               libvtk6-dev,
               libxi-dev,
               libxmu-dev,
               pyqt5-dev-tools,
               python-all-dev,
               python-gts,
               python-pil,
               python-matplotlib,
               python-minieigen,
               python-numpy,
               python-sip,
               python-pyqt5,
               python-pyqt5.qtsvg,
               python-tk,
               python-xlib,
               zlib1g-dev
Build-Depends-Indep: dvipng,
                     graphviz,
                     libjs-jquery,
                     lmodern,
                     python-bibtex,
                     python-sphinx,
                     texlive-fonts-recommended,
                     texlive-generic-extra,
                     texlive-latex-extra,
                     texlive-latex-recommended,
                     texlive-pictures,
                     texlive-xetex,
                     tipa
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/science-team/yade.git
Vcs-Git: https://salsa.debian.org/science-team/yade.git
Homepage: https://yade-dem.org/doc/
X-Python-Version: current

Package: yade
Architecture: any
Multi-Arch: foreign
Depends: gnuplot,
         gtk2-engines-pixbuf,
         ipython,
         libyade (= ${binary:Version}),
         python-yade (= ${binary:Version}),
         python-pyqt5.qtwebkit,
         ${python:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Platform for discrete element modeling
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains speed-optimized build of yade.

Package: libyade
Architecture: any
Multi-Arch: same
Depends: libopenblas-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Platform for discrete element modeling. Libraries
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains yade`s libraries.

Package: python-yade
Architecture: any
Multi-Arch: foreign
Section: python
Depends: libyade (= ${binary:Version}),
         python-argparse,
         python-gts,
         python-pil,
         python-matplotlib,
         python-minieigen,
         python-pyqt5,
         python-pyqt5.qtsvg,
         python-tk,
         python-xlib,
         ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Platform for discrete element modeling. Python bindings
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains python bindings for yade.

Package: yade-doc
Architecture: all
Section: doc
Depends: ${sphinxdoc:Depends},
         ${misc:Depends}
Recommends: yade
Description: Platform for discrete element modeling. Documentation
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains examples, test scripts and documentation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

BUILDDIR = $(CURDIR)/debian/build
tmpInstall = $(CURDIR)/debian/tmp
tmpDirMatplotLib = $(CURDIR)/debian/matplotlib

%:
	dh $@ --builddirectory=$(BUILDDIR) --with python2 --no-parallel

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed,-no-keep-memory

# no debug info to avoid running
# out of address space when linking
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
	export DEB_CXXFLAGS_MAINT_APPEND += -g0
endif

# Check, whether Build-Depends-Indep are installed
BUILD_DOC=$(shell dpkg -s python-sphinx | grep -q "^Status:.* installed$$" && echo yes)

export MPLCONFIGDIR := $(tmpDirMatplotLib)
export HOME := $(tmpDirMatplotLib)
export LD_LIBRARY_PATH :=  $(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/gts:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/yade/qt:$(LD_LIBRARY_PATH);
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export YADE_PREFIX := $(tmpInstall)/usr

extra_flags += \
-DruntimePREFIX="/usr" \
-DCMAKE_INSTALL_PREFIX="/usr" \
-DNOSUFFIX=ON \
-DLIBRARY_OUTPUT_PATH=lib/$(DEB_HOST_MULTIARCH) \
-DUSE_QT5=ON \
-DENABLE_SPH=ON

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)
	mkdir -p $(tmpDirMatplotLib)
	mkdir -p $(tmpInstall)
	#Output an information about available memory and CPU
	-cat /proc/meminfo
	-cat /proc/cpuinfo

override_dh_auto_install:
	dh_auto_install
	# generate manpages
	help2man $(tmpInstall)/usr/bin/yade > yade.1
	help2man $(tmpInstall)/usr/bin/yade-batch > yade-batch.1
	$(tmpInstall)/usr/bin/yade --test
	$(tmpInstall)/usr/bin/yade --check
	dh_numpy
ifeq ($(BUILD_DOC), yes)
	#Generate docs
	cd $(CURDIR)/doc/sphinx; PYTHONPATH=. $(tmpInstall)/usr/bin/yade yadeSphinx.py
endif
	#Delete all pyc files
	find . -name '*.pyc' -print0 | xargs -0 rm -f

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_installman:
	dh_installman -p yade yade.1 yade-batch.1

override_dh_compress:
	dh_compress --all -X.py -X.stl -X.gts -X.geo -X.mesh -X.msh -X.pdf -X.png -X.svg -X.txt -X.js -X.inv

override_dh_auto_test: 

override_dh_installdocs:
	dh_installdocs
ifeq ($(BUILD_DOC), yes)
	dh_sphinxdoc
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)

## yade 2019.01a

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,7 @@
 #  CHUNKSIZE: set >1, if you want several sources to be compiled at once. Increases compilation speed and RAM-consumption during it (1 by default)
 #  VECTORIZE: enables vectorization and alignment in Eigen3 library, experimental (OFF by default)
 #  USE_QT5: use QT5 for GUI (ON by default)
+#  CHOLMOD_GPU link Yade to custom SuiteSparse installation and activate GPU accelerated PFV (OFF by default)
 
 project(Yade C CXX)
 cmake_minimum_required(VERSION 2.8.11)
@@ -59,8 +60,14 @@
 
 EXECUTE_PROCESS(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
 IF (GCC_VERSION VERSION_GREATER 4.8 OR GCC_VERSION VERSION_EQUAL 4.8)
-  MESSAGE(STATUS "GCC Version >= 4.8. Adding -ftrack-macro-expansion=0 and -save-temps")
-  ADD_DEFINITIONS("-ftrack-macro-expansion=0 -save-temps")
+  MESSAGE(STATUS "GCC Version >= 4.8. Adding -ftrack-macro-expansion=0")
+  ADD_DEFINITIONS("-ftrack-macro-expansion=0")
+ENDIF()
+
+# -save-temps is not supported with ccache
+IF ((GCC_VERSION VERSION_GREATER 4.8 OR GCC_VERSION VERSION_EQUAL 4.8) AND ( NOT "${CMAKE_CXX_COMPILER_LAUNCHER}" MATCHES ".*ccache" AND NOT DISABLE_SAVE_TEMPS))
+  MESSAGE(STATUS "GCC Version >= 4.8. Adding -save-temps")
+  ADD_DEFINITIONS("-save-temps")
 ENDIF()
 
 #===========================================================
@@ -141,7 +148,8 @@
 OPTION(USE_QT5 "USE Qt5 for GUI" ON)
 OPTION(ENABLE_POTENTIAL_BLOCKS "Enable PotentialBlocks" OFF)
 OPTION(ENABLE_DEFORM "Enable Deformation Engine" OFF)
-OPTION(CHOLMOD_GPU "Enable GPU acceleration flow engine direct solver (experimental)" OFF)
+OPTION(CHOLMOD_GPU "Enable GPU acceleration flow engine direct solver" OFF)
+OPTION(ENABLE_THERMAL "Enable thermal engine (experimental)" OFF)
 
 #===========================================================
 # Use Eigen3 by default
@@ -235,6 +243,7 @@
   FIND_PACKAGE(glib2)
     
   IF(USE_QT5)
+    MESSAGE(STATUS "USE QT5")
     FIND_PACKAGE(QGLVIEWER-qt5 REQUIRED)
     FIND_PACKAGE(Qt5 CONFIG REQUIRED Widgets Xml OpenGL)
     SET(CMAKE_AUTOMOC ON)
@@ -248,11 +257,3 @@
       SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GUI-Qt5")
     ELSE(Qt5Widgets_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
       MESSAGE(STATUS "GUI-Qt5-LIBS NOT found")
-      SET(DISABLED_FEATS "${DISABLED_FEATS} GUI-Qt5")
-      SET(ENABLE_GUI OFF)
-    ENDIF(Qt5Widgets_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
-  ELSE(USE_QT5)   # Use Qt4
-    FIND_PACKAGE(QGLVIEWER-qt4 REQUIRED)
-    FIND_PACKAGE(Qt4 COMPONENTS QtCore QtGui QtOpenGL)
-    IF(QT4_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
-      SET(GUI_LIBS ${GLUT_LIBRARY} ${OPENGL_LIBRARY} ${QGLVIEWER_LIBRARIES})

=== debian/changelog ===
yade (2019.01a-3build1) eoan; urgency=medium

  * Rebuild against bump version because previous one wasn't uploaded
    correctly.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 07 Sep 2019 23:58:03 +0200

yade (2019.01a-3) unstable; urgency=medium

  * [b94a2c7] Remove restriction version on libeigen3-dev
  * [118eccb] Add texlive-plain-generic as alternative to texlive-generic-extra 
              (Closes: #933591)
  * [02dc167] Trim trailing whitespace.

 -- Anton Gladky <gladk@debian.org>  Sat, 24 Aug 2019 17:26:37 +0200

yade (2019.01a-2) unstable; urgency=medium

  * [67c1798] Let metis. openblas and suiteparse be installed on all archs

 -- Anton Gladky <gladk@debian.org>  Wed, 30 Jan 2019 19:41:45 +0100

yade (2019.01a-1) unstable; urgency=medium

  * [6b3c3c1] New upstream version 2019.01a
  * [34e8a66] Refresh patches
  * [337fccf] Remove privacy breach
  * [31d5dc1] Remove deprecated x-python-version
  * [1584879] Fix typo
  * [195bb4f] Set Standards-Version to 4.3.0
  * [8401a0b] Build yade only for amd64 arm64 i386 ppc64el s390x

 -- Anton Gladky <gladk@debian.org>  Tue, 29 Jan 2019 20:30:49 +0100

yade (2018.02b-6) unstable; urgency=medium

  * [3251aa0] Reenable cgal-build

 -- Anton Gladky <gladk@debian.org>  Mon, 07 Jan 2019 20:22:40 +0100

yade (2018.02b-5) unstable; urgency=medium

  * [ef8bc89] Disable cgal functionality. (Closes: #911685)
  * [75b0b55] Set Standards-Version to 4.2.1

 -- Anton Gladky <gladk@debian.org>  Wed, 05 Dec 2018 21:39:37 +0100

=== debian/control ===
--- 
+++ 
@@ -12,15 +12,15 @@
                libboost-all-dev,
                libbz2-dev,
                libcgal-dev,
-               libeigen3-dev (>= 3.2.1-2),
+               libeigen3-dev,
                libgl1-mesa-dev,
                libgmp-dev,
                libgts-dev,
                libloki-dev,
-               libmetis-dev [amd64 i386 powerpc],
-               libopenblas-dev [amd64 i386 powerpc],
+               libmetis-dev,
+               libopenblas-dev,
                libqglviewer-dev-qt5,
-               libsuitesparse-dev [amd64 i386 powerpc],
+               libsuitesparse-dev,
                libvtk6-dev,
                libxi-dev,
                libxmu-dev,
@@ -44,20 +44,19 @@
                      python-bibtex,
                      python-sphinx,
                      texlive-fonts-recommended,
-                     texlive-generic-extra,
+                     texlive-generic-extra | texlive-plain-generic,
                      texlive-latex-extra,
                      texlive-latex-recommended,
                      texlive-pictures,
                      texlive-xetex,
                      tipa
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/science-team/yade.git
 Vcs-Git: https://salsa.debian.org/science-team/yade.git
 Homepage: https://yade-dem.org/doc/
-X-Python-Version: current
 
 Package: yade
-Architecture: any
+Architecture: amd64 arm64 i386 ppc64el s390x
 Multi-Arch: foreign
 Depends: gnuplot,
          gtk2-engines-pixbuf,
@@ -81,7 +80,7 @@
  This package contains speed-optimized build of yade.
 
 Package: libyade
-Architecture: any
+Architecture: amd64 arm64 i386 ppc64el s390x
 Multi-Arch: same
 Depends: libopenblas-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
          ${misc:Depends},
@@ -100,7 +99,7 @@
  This package contains yade`s libraries.
 
 Package: python-yade
-Architecture: any
+Architecture: amd64 arm64 i386 ppc64el s390x
 Multi-Arch: foreign
 Section: python
 Depends: libyade (= ${binary:Version}),
@@ -133,7 +132,8 @@
 Architecture: all
 Section: doc
 Depends: ${sphinxdoc:Depends},
-         ${misc:Depends}
+         ${misc:Depends},
+         libjs-mathjax
 Recommends: yade
 Description: Platform for discrete element modeling. Documentation
  Yet Another Dynamic Engine.

=== debian/rules ===
--- 
+++ 
@@ -53,6 +53,7 @@
 ifeq ($(BUILD_DOC), yes)
 	#Generate docs
 	cd $(CURDIR)/doc/sphinx; PYTHONPATH=. $(tmpInstall)/usr/bin/yade yadeSphinx.py
+	cd $(CURDIR)/doc/sphinx/_build/html ; find . -type f -print0 | xargs -0 sed -i 's/https:\/\/cdnjs\.cloudflare\.com\/ajax\/libs\/mathjax\/2\.7\.5\/latest.js/\/usr\/share\/javascript\/mathjax\/MathJax.js\//g'
 endif
 	#Delete all pyc files
 	find . -name '*.pyc' -print0 | xargs -0 rm -f
@@ -66,7 +67,7 @@
 override_dh_compress:
 	dh_compress --all -X.py -X.stl -X.gts -X.geo -X.mesh -X.msh -X.pdf -X.png -X.svg -X.txt -X.js -X.inv
 
-override_dh_auto_test: 
+override_dh_auto_test:
 
 override_dh_installdocs:
 	dh_installdocs
@@ -77,4 +78,3 @@
 override_dh_auto_clean:
 	dh_auto_clean
 	rm -rf $(BUILDDIR)
-
